package simplyconnect.mail.bounce

import simplyconnect.mail.MessageWrapper

/**
 * User: david
 * Date: 24/03/13
 * Time: 8:14 PM
 */
class Categoriser {
    List<CategoryMatch> matchers = []

    Categoriser(File configDir) {
        initMatchers(configDir)
    }

    void initMatchers(File configDir) {
        // TODO read these from config file
        matchers << new CategoryMatch(expression:  "out of office", type:  Category.TYPE_INFO, category: Category.CATEGORY_AUTOREPLY, subCategory: "out-of-office")
    }

    Category categorise(MessageWrapper message) {
        String contentType = message.message.getContentType()
        if (contentType.contains("multipart/report")) {
            println "this is a multipart report"
            if (contentType.contains("report-type=delivery-status")) {
                println "This is a delivery status"

            }
        }
        // if content type == multipart/report
        //     if report-type == delivery-status
        //          get that part and determine more about it -
        //          final-recipient-field
        //             "Final-Recipient" ":" address-type ";" generic-address
        //          action-field
        //             action-field = "Action" ":" action-value
        //             action-value = "failed" / "delayed" / "delivered" / "relayed" / "expanded"
        //          status-field
        //            status-field = "Status" ":" status-code
        //            status-code = DIGIT "." 1*3DIGIT "." 1*3DIGIT
        //     if report-type == disposition-notification
        //          get that part and determine more about it
        // if content type != multipart/report
        //     join subject with content and apply expressions to find out type of email
        String content = message.subject.toLowerCase() +
                System.getProperty("line.separator") +
                message.getHtmlContentWithoutMarkup().toLowerCase()
        Category category = match(content, message)
        return category
    }

    Category match(String content, MessageWrapper messageWrapper) {
        Category category = null
        matchers.each { CategoryMatch matcher ->
            // TODO should we always match against all content - should any match just against subject?
            if (content.contains(matcher.expression)) {
                category = matcher.createCategory()
            }
        }
        if (!category) {
            category = new Category(Category.TYPE_UNKNOWN, Category.CATEGORY_UNKNOWN)
        }
        return category
    }
}
